<?php
class EnumerationIterator implements JavaIterator {
	private $enumeration;

	public function __construct( Enumeration $enumeration ) {
		$this->enumeration = $enumeration;
	}

	public function hasNext() {
		return $this->enumeration->hasMoreElements();
	}

	public function next() {
		return $this->enumeration->nextElement();
	}

	public function current() {
		return $this->enumeration->currentElement();
	}

	public function __get( $key ) {
		if( isset( $this->enumeration->$key ) ) {
			return $this->enumeration->$key;
		}
	}

	public function remove() {
		throw new UnsupportedOperationException( "remove() operation is not supported" );
	}
}

class UnsupportedOperationException extends Exception {
}