<?php
require_once( 'Enumeration.php' );
require_once( 'JavaIterator.php' );

require_once( 'EnumerationIterator.class.php' );

class EnumerationExample implements Enumeration {
	private $elements = array( 1, 2, 3, 4, 5 );
	public $current = 0;

	public function hasMoreElements() {
		$result = false;

		if( !empty( $this->elements[ $this->current ] ) ) {
			$result = true;
		}

		return $result;
	}

	public function nextElement() {
		$this->current++;
	}

	public function currentElement() {
		return $this->elements[ $this->current ];
	}

	public function reset() {
		$this->current = 0;
	}

}

class JavaIteratorExample implements JavaIterator {
	private $elements = array( 6, 7, 8, 9, 10 );
	public $current = 0;

	public function hasNext() {
		return !empty( $this->elements[ $this->current ] );
	}

	public function next() {
		$this->current++;
	}

	public function current() {
		return $this->elements[ $this->current ];
	}

	public function reset() {
		$this->current = 0;
	}

	public function remove() {
		$number = ($this->current + 1);
		$currentVal = $this->current();
		echo "Pretending that removing element #$number which equals $currentVal...\n";
	}

}


$e = new EnumerationExample();
echo "\nThis is how EnumerationExample works: \n";
while( $e->hasMoreElements() ) {
	echo $e->current . " = " . $e->currentElement() . "\n";
	$e->nextElement();
}

$i = new JavaIteratorExample();
echo "\nThis is how JavaIteratorExample works: \n";
while( $i->hasNext() ) {
	echo $i->current . " = " . $i->current() . "\n";
	$i->next();
}
echo "We can even delete 2nd element: \n";
$i->reset();
$i->next();
$i->remove();

echo "\nThis is how EnumerationIterator works: \n";
$e->reset();
$ei = new EnumerationIterator( $e );
while( $ei->hasNext() ) {
	echo $ei->current . " = " . $ei->current() . "\n";
	$ei->next();
}
echo "But deleting an element won't work: \n";
$ei->remove();